/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.wrapper;

import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.estate.entity.WorkOrderGroup;
import org.springblade.estate.vo.WorkOrderGroupSimpleVO;
import org.springblade.estate.vo.WorkOrderGroupVO;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * 工单团队包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2022-01-19
 */
public class WorkOrderGroupWrapper extends BaseEntityWrapper<WorkOrderGroup, WorkOrderGroupVO>  {

	private static IResidentialClient residentialClient;

	public static WorkOrderGroupWrapper build() {
		return new WorkOrderGroupWrapper();
 	}

 	static {
		residentialClient = SpringUtil.getBean(IResidentialClient.class);
	}

	@Override
	public WorkOrderGroupVO entityVO(WorkOrderGroup workOrderGroup) {
		WorkOrderGroupVO workOrderGroupVO = Objects.requireNonNull(BeanUtil.copy(workOrderGroup, WorkOrderGroupVO.class));
		Residential residential = residentialClient.getById(workOrderGroup.getResidentialId());
		if(residential != null){
			workOrderGroupVO.setResidentialName(residential.getName());
		}
		return workOrderGroupVO;
	}

	public WorkOrderGroupSimpleVO entitySimpleVO(WorkOrderGroup workOrderGroup) {
		WorkOrderGroupSimpleVO workOrderGroupVO = Objects.requireNonNull(BeanUtil.copy(workOrderGroup, WorkOrderGroupSimpleVO.class));
		return workOrderGroupVO;
	}

	public List<WorkOrderGroupSimpleVO> listSimpleVO(List<WorkOrderGroup> workOrderGroupList) {
		return workOrderGroupList.stream().map(this::entitySimpleVO).collect(Collectors.toList());
	}

}
